// as21.h   16 Jan 2007


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define PRIVATE   static

#define NOP 0
#define LD 1		// op code number
#define ST 2
#define MV 3
#define JMP 4
#define JAL 5
#define JT  6
#define JF  7
#define RET 8
#define ADD 9
#define SUB 10
#define MUL 11
#define DIV 12
#define AND 13
#define OR 14
#define XOR 15
#define EQ 16
#define NE 17
#define LT 18
#define LE 19
#define GT 20
#define GE 21
#define SHL 22
#define SHR 23
#define TRAP 24
#define XL 25
#define XD 26
#define XX 27

#define ABS 30		// addressing modes
#define IND 31
#define INX 32
#define IMM 33		// for two arg
#define REG 48
#define RR 34
#define RI 35
#define SP 36
#define NA 37

#define SYM 41		// type of symbol
#define NUM 42
#define OP 43
#define DOTS 44
#define DOTC 45
#define DOTD 46
#define DOTE 47

#define MEM 50		// check arg, mem: ABS,IND,INX
#define MOV 51		// mv: IMM, REG
#define RRI	52		// RI, RR

#define UNDEF 0x80000000	// max neg int, denote undef in sym tab
#define	MXBUF	200			// max input line length
#define MXMEM	5000		// max no of token

#define eqs(a,b)  strcmp((a),(b)) == 0

typedef struct { char type; char mode; int ref; int line; } token;

// hash symbol table functions from hash.c
int searchsym(char *s);
int putsym(char *s);
//int getsym(char *s,int *type);
void putvalue(int idx, int value);
void error(char *s);
int getValue(int idx);
int getArg(int idx);
int getType(int idx);
void setsym(int idx, int value, int type, int arg);
